// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_object_msgs:msg/Object.idl
// generated code does not contain a copyright notice
#include "tuw_object_msgs/msg/detail/object__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `ids`
// Member `shape_variables`
// Member `ids_confidence`
#include "rosidl_runtime_c/primitives_sequence_functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `twist`
#include "geometry_msgs/msg/detail/twist__functions.h"

bool
tuw_object_msgs__msg__Object__init(tuw_object_msgs__msg__Object * msg)
{
  if (!msg) {
    return false;
  }
  // ids
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->ids, 0)) {
    tuw_object_msgs__msg__Object__fini(msg);
    return false;
  }
  // shape
  // shape_variables
  if (!rosidl_runtime_c__double__Sequence__init(&msg->shape_variables, 0)) {
    tuw_object_msgs__msg__Object__fini(msg);
    return false;
  }
  // ids_confidence
  if (!rosidl_runtime_c__double__Sequence__init(&msg->ids_confidence, 0)) {
    tuw_object_msgs__msg__Object__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    tuw_object_msgs__msg__Object__fini(msg);
    return false;
  }
  // twist
  if (!geometry_msgs__msg__Twist__init(&msg->twist)) {
    tuw_object_msgs__msg__Object__fini(msg);
    return false;
  }
  return true;
}

void
tuw_object_msgs__msg__Object__fini(tuw_object_msgs__msg__Object * msg)
{
  if (!msg) {
    return;
  }
  // ids
  rosidl_runtime_c__int32__Sequence__fini(&msg->ids);
  // shape
  // shape_variables
  rosidl_runtime_c__double__Sequence__fini(&msg->shape_variables);
  // ids_confidence
  rosidl_runtime_c__double__Sequence__fini(&msg->ids_confidence);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // twist
  geometry_msgs__msg__Twist__fini(&msg->twist);
}

bool
tuw_object_msgs__msg__Object__are_equal(const tuw_object_msgs__msg__Object * lhs, const tuw_object_msgs__msg__Object * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // ids
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->ids), &(rhs->ids)))
  {
    return false;
  }
  // shape
  if (lhs->shape != rhs->shape) {
    return false;
  }
  // shape_variables
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->shape_variables), &(rhs->shape_variables)))
  {
    return false;
  }
  // ids_confidence
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->ids_confidence), &(rhs->ids_confidence)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // twist
  if (!geometry_msgs__msg__Twist__are_equal(
      &(lhs->twist), &(rhs->twist)))
  {
    return false;
  }
  return true;
}

bool
tuw_object_msgs__msg__Object__copy(
  const tuw_object_msgs__msg__Object * input,
  tuw_object_msgs__msg__Object * output)
{
  if (!input || !output) {
    return false;
  }
  // ids
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->ids), &(output->ids)))
  {
    return false;
  }
  // shape
  output->shape = input->shape;
  // shape_variables
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->shape_variables), &(output->shape_variables)))
  {
    return false;
  }
  // ids_confidence
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->ids_confidence), &(output->ids_confidence)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // twist
  if (!geometry_msgs__msg__Twist__copy(
      &(input->twist), &(output->twist)))
  {
    return false;
  }
  return true;
}

tuw_object_msgs__msg__Object *
tuw_object_msgs__msg__Object__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__msg__Object * msg = (tuw_object_msgs__msg__Object *)allocator.allocate(sizeof(tuw_object_msgs__msg__Object), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_object_msgs__msg__Object));
  bool success = tuw_object_msgs__msg__Object__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_object_msgs__msg__Object__destroy(tuw_object_msgs__msg__Object * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_object_msgs__msg__Object__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_object_msgs__msg__Object__Sequence__init(tuw_object_msgs__msg__Object__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__msg__Object * data = NULL;

  if (size) {
    data = (tuw_object_msgs__msg__Object *)allocator.zero_allocate(size, sizeof(tuw_object_msgs__msg__Object), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_object_msgs__msg__Object__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_object_msgs__msg__Object__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_object_msgs__msg__Object__Sequence__fini(tuw_object_msgs__msg__Object__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_object_msgs__msg__Object__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_object_msgs__msg__Object__Sequence *
tuw_object_msgs__msg__Object__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__msg__Object__Sequence * array = (tuw_object_msgs__msg__Object__Sequence *)allocator.allocate(sizeof(tuw_object_msgs__msg__Object__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_object_msgs__msg__Object__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_object_msgs__msg__Object__Sequence__destroy(tuw_object_msgs__msg__Object__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_object_msgs__msg__Object__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_object_msgs__msg__Object__Sequence__are_equal(const tuw_object_msgs__msg__Object__Sequence * lhs, const tuw_object_msgs__msg__Object__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_object_msgs__msg__Object__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_object_msgs__msg__Object__Sequence__copy(
  const tuw_object_msgs__msg__Object__Sequence * input,
  tuw_object_msgs__msg__Object__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_object_msgs__msg__Object);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_object_msgs__msg__Object * data =
      (tuw_object_msgs__msg__Object *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_object_msgs__msg__Object__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_object_msgs__msg__Object__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_object_msgs__msg__Object__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
