// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_object_msgs:msg/Object.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT__STRUCT_H_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SHAPE_UNKOWN'.
/**
  * SHAPE_TYPE                      # SHAPE_VARIABLES
  * ====================================================
  * []
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_UNKOWN = 0l
};

/// Constant 'SHAPE_POINT'.
/**
  * []
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_POINT = 1l
};

/// Constant 'SHAPE_CIRCLE'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_CIRCLE = 2l
};

/// Constant 'SHAPE_ELLIPSE'.
/**
  * [radius1, radius2]
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_ELLIPSE = 3l
};

/// Constant 'SHAPE_SQUARE'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_SQUARE = 4l
};

/// Constant 'SHAPE_RECTANGLE'.
/**
  * [length, width]
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_RECTANGLE = 5l
};

/// Constant 'SHAPE_HULL'.
/**
  * [p0, p1, p2, ...]
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_HULL = 6l
};

/// Constant 'SHAPE_LINE'.
/**
  * [] or
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_LINE = 7l
};

/// Constant 'SHAPE_SPHERE'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_SPHERE = 102l
};

/// Constant 'SHAPE_ELLIPSOID'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_ELLIPSOID = 103l
};

/// Constant 'SHAPE_CUBE'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_CUBE = 104l
};

/// Constant 'SHAPE_BOX'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_BOX = 105l
};

/// Constant 'SHAPE_MESH'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_MESH = 106l
};

/// Constant 'SHAPE_TRAFFIC_CONE'.
/**
  * [radius, color(1 = blue, 2 = yellow, 3 = red)]
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_TRAFFIC_CONE = 201l
};

/// Constant 'SHAPE_DOOR'.
/**
  * [width, height, opening angle (0=closed), nr of door leafs, clockwise (0) counterclockwise (1)]
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_DOOR = 202l
};

/// Constant 'SHAPE_MAP_DOOR'.
/**
  * for doors already mapped, same parameters as usual door
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_MAP_DOOR = 212l
};

/// Constant 'SHAPE_PERSON'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_PERSON = 203l
};

/// Constant 'SHAPE_VEHICLE'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_VEHICLE = 204l
};

/// Constant 'SHAPE_FIDUCIAL'.
enum
{
  tuw_object_msgs__msg__Object__SHAPE_FIDUCIAL = 205l
};

/// Constant 'SHAPE_CONE'.
/**
  * [radius, height]
 */
enum
{
  tuw_object_msgs__msg__Object__SHAPE_CONE = 206l
};

// Include directives for member types
// Member 'ids'
// Member 'shape_variables'
// Member 'ids_confidence'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'twist'
#include "geometry_msgs/msg/detail/twist__struct.h"

/// Struct defined in msg/Object in the package tuw_object_msgs.
/**
  * This expresses a object in a 3D space
 */
typedef struct tuw_object_msgs__msg__Object
{
  /// possible ids of the detected object (empty if no id could be identified/assigned)
  rosidl_runtime_c__int32__Sequence ids;
  /// shape type (possible types are listed below)
  int32_t shape;
  /// variables correspoding to the shape of the object (possible types are listed below)
  rosidl_runtime_c__double__Sequence shape_variables;
  /// confidence of the possible ids in [0, 1]
  rosidl_runtime_c__double__Sequence ids_confidence;
  /// pose of the detected object
  geometry_msgs__msg__Pose pose;
  /// twist of the detected object
  geometry_msgs__msg__Twist twist;
} tuw_object_msgs__msg__Object;

// Struct for a sequence of tuw_object_msgs__msg__Object.
typedef struct tuw_object_msgs__msg__Object__Sequence
{
  tuw_object_msgs__msg__Object * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_object_msgs__msg__Object__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT__STRUCT_H_
