// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_object_msgs:msg/Object.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_object_msgs/msg/detail/object__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'twist'
#include "geometry_msgs/msg/detail/twist__traits.hpp"

namespace tuw_object_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Object & msg,
  std::ostream & out)
{
  out << "{";
  // member: ids
  {
    if (msg.ids.size() == 0) {
      out << "ids: []";
    } else {
      out << "ids: [";
      size_t pending_items = msg.ids.size();
      for (auto item : msg.ids) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: shape
  {
    out << "shape: ";
    rosidl_generator_traits::value_to_yaml(msg.shape, out);
    out << ", ";
  }

  // member: shape_variables
  {
    if (msg.shape_variables.size() == 0) {
      out << "shape_variables: []";
    } else {
      out << "shape_variables: [";
      size_t pending_items = msg.shape_variables.size();
      for (auto item : msg.shape_variables) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: ids_confidence
  {
    if (msg.ids_confidence.size() == 0) {
      out << "ids_confidence: []";
    } else {
      out << "ids_confidence: [";
      size_t pending_items = msg.ids_confidence.size();
      for (auto item : msg.ids_confidence) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: twist
  {
    out << "twist: ";
    to_flow_style_yaml(msg.twist, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Object & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ids.size() == 0) {
      out << "ids: []\n";
    } else {
      out << "ids:\n";
      for (auto item : msg.ids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: shape
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "shape: ";
    rosidl_generator_traits::value_to_yaml(msg.shape, out);
    out << "\n";
  }

  // member: shape_variables
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.shape_variables.size() == 0) {
      out << "shape_variables: []\n";
    } else {
      out << "shape_variables:\n";
      for (auto item : msg.shape_variables) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: ids_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ids_confidence.size() == 0) {
      out << "ids_confidence: []\n";
    } else {
      out << "ids_confidence:\n";
      for (auto item : msg.ids_confidence) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: twist
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "twist:\n";
    to_block_style_yaml(msg.twist, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Object & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_object_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_object_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_object_msgs::msg::Object & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_object_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_object_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_object_msgs::msg::Object & msg)
{
  return tuw_object_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_object_msgs::msg::Object>()
{
  return "tuw_object_msgs::msg::Object";
}

template<>
inline const char * name<tuw_object_msgs::msg::Object>()
{
  return "tuw_object_msgs/msg/Object";
}

template<>
struct has_fixed_size<tuw_object_msgs::msg::Object>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_object_msgs::msg::Object>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_object_msgs::msg::Object>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_
