// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_object_msgs:msg/ObjectWithCovariance.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE__TRAITS_HPP_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_object_msgs/msg/detail/object_with_covariance__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'object'
#include "tuw_object_msgs/msg/detail/object__traits.hpp"

namespace tuw_object_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ObjectWithCovariance & msg,
  std::ostream & out)
{
  out << "{";
  // member: object
  {
    out << "object: ";
    to_flow_style_yaml(msg.object, out);
    out << ", ";
  }

  // member: covariance_pose
  {
    if (msg.covariance_pose.size() == 0) {
      out << "covariance_pose: []";
    } else {
      out << "covariance_pose: [";
      size_t pending_items = msg.covariance_pose.size();
      for (auto item : msg.covariance_pose) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: covariance_twist
  {
    if (msg.covariance_twist.size() == 0) {
      out << "covariance_twist: []";
    } else {
      out << "covariance_twist: [";
      size_t pending_items = msg.covariance_twist.size();
      for (auto item : msg.covariance_twist) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: correlation
  {
    if (msg.correlation.size() == 0) {
      out << "correlation: []";
    } else {
      out << "correlation: [";
      size_t pending_items = msg.correlation.size();
      for (auto item : msg.correlation) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ObjectWithCovariance & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: object
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object:\n";
    to_block_style_yaml(msg.object, out, indentation + 2);
  }

  // member: covariance_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.covariance_pose.size() == 0) {
      out << "covariance_pose: []\n";
    } else {
      out << "covariance_pose:\n";
      for (auto item : msg.covariance_pose) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: covariance_twist
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.covariance_twist.size() == 0) {
      out << "covariance_twist: []\n";
    } else {
      out << "covariance_twist:\n";
      for (auto item : msg.covariance_twist) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: correlation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.correlation.size() == 0) {
      out << "correlation: []\n";
    } else {
      out << "correlation:\n";
      for (auto item : msg.correlation) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ObjectWithCovariance & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_object_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_object_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_object_msgs::msg::ObjectWithCovariance & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_object_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_object_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_object_msgs::msg::ObjectWithCovariance & msg)
{
  return tuw_object_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_object_msgs::msg::ObjectWithCovariance>()
{
  return "tuw_object_msgs::msg::ObjectWithCovariance";
}

template<>
inline const char * name<tuw_object_msgs::msg::ObjectWithCovariance>()
{
  return "tuw_object_msgs/msg/ObjectWithCovariance";
}

template<>
struct has_fixed_size<tuw_object_msgs::msg::ObjectWithCovariance>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_object_msgs::msg::ObjectWithCovariance>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_object_msgs::msg::ObjectWithCovariance>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE__TRAITS_HPP_
