// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_object_msgs:msg/ObjectWithCovarianceArray.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE_ARRAY__TRAITS_HPP_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_object_msgs/msg/detail/object_with_covariance_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'objects'
#include "tuw_object_msgs/msg/detail/object_with_covariance__traits.hpp"

namespace tuw_object_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ObjectWithCovarianceArray & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: objects
  {
    if (msg.objects.size() == 0) {
      out << "objects: []";
    } else {
      out << "objects: [";
      size_t pending_items = msg.objects.size();
      for (auto item : msg.objects) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ObjectWithCovarianceArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: objects
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.objects.size() == 0) {
      out << "objects: []\n";
    } else {
      out << "objects:\n";
      for (auto item : msg.objects) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ObjectWithCovarianceArray & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_object_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_object_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_object_msgs::msg::ObjectWithCovarianceArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_object_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_object_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_object_msgs::msg::ObjectWithCovarianceArray & msg)
{
  return tuw_object_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_object_msgs::msg::ObjectWithCovarianceArray>()
{
  return "tuw_object_msgs::msg::ObjectWithCovarianceArray";
}

template<>
inline const char * name<tuw_object_msgs::msg::ObjectWithCovarianceArray>()
{
  return "tuw_object_msgs/msg/ObjectWithCovarianceArray";
}

template<>
struct has_fixed_size<tuw_object_msgs::msg::ObjectWithCovarianceArray>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_object_msgs::msg::ObjectWithCovarianceArray>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_object_msgs::msg::ObjectWithCovarianceArray>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE_ARRAY__TRAITS_HPP_
