// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_object_msgs:msg/Shape.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__SHAPE__TRAITS_HPP_
#define TUW_OBJECT_MSGS__MSG__DETAIL__SHAPE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_object_msgs/msg/detail/shape__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'poses'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'params_poses'
// Member 'params'
#include "tuw_std_msgs/msg/detail/parameter_array__traits.hpp"

namespace tuw_object_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Shape & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: shape
  {
    out << "shape: ";
    rosidl_generator_traits::value_to_yaml(msg.shape, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: poses
  {
    if (msg.poses.size() == 0) {
      out << "poses: []";
    } else {
      out << "poses: [";
      size_t pending_items = msg.poses.size();
      for (auto item : msg.poses) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: params_poses
  {
    if (msg.params_poses.size() == 0) {
      out << "params_poses: []";
    } else {
      out << "params_poses: [";
      size_t pending_items = msg.params_poses.size();
      for (auto item : msg.params_poses) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: params
  {
    out << "params: ";
    to_flow_style_yaml(msg.params, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Shape & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: shape
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "shape: ";
    rosidl_generator_traits::value_to_yaml(msg.shape, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: poses
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.poses.size() == 0) {
      out << "poses: []\n";
    } else {
      out << "poses:\n";
      for (auto item : msg.poses) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: params_poses
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.params_poses.size() == 0) {
      out << "params_poses: []\n";
    } else {
      out << "params_poses:\n";
      for (auto item : msg.params_poses) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: params
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "params:\n";
    to_block_style_yaml(msg.params, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Shape & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_object_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_object_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_object_msgs::msg::Shape & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_object_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_object_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_object_msgs::msg::Shape & msg)
{
  return tuw_object_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_object_msgs::msg::Shape>()
{
  return "tuw_object_msgs::msg::Shape";
}

template<>
inline const char * name<tuw_object_msgs::msg::Shape>()
{
  return "tuw_object_msgs/msg/Shape";
}

template<>
struct has_fixed_size<tuw_object_msgs::msg::Shape>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_object_msgs::msg::Shape>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_object_msgs::msg::Shape>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__SHAPE__TRAITS_HPP_
