// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_object_msgs:srv/GetShapeArray.idl
// generated code does not contain a copyright notice
#include "tuw_object_msgs/srv/detail/get_shape_array__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
tuw_object_msgs__srv__GetShapeArray_Request__init(tuw_object_msgs__srv__GetShapeArray_Request * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
tuw_object_msgs__srv__GetShapeArray_Request__fini(tuw_object_msgs__srv__GetShapeArray_Request * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
tuw_object_msgs__srv__GetShapeArray_Request__are_equal(const tuw_object_msgs__srv__GetShapeArray_Request * lhs, const tuw_object_msgs__srv__GetShapeArray_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
tuw_object_msgs__srv__GetShapeArray_Request__copy(
  const tuw_object_msgs__srv__GetShapeArray_Request * input,
  tuw_object_msgs__srv__GetShapeArray_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

tuw_object_msgs__srv__GetShapeArray_Request *
tuw_object_msgs__srv__GetShapeArray_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__srv__GetShapeArray_Request * msg = (tuw_object_msgs__srv__GetShapeArray_Request *)allocator.allocate(sizeof(tuw_object_msgs__srv__GetShapeArray_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_object_msgs__srv__GetShapeArray_Request));
  bool success = tuw_object_msgs__srv__GetShapeArray_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_object_msgs__srv__GetShapeArray_Request__destroy(tuw_object_msgs__srv__GetShapeArray_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_object_msgs__srv__GetShapeArray_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_object_msgs__srv__GetShapeArray_Request__Sequence__init(tuw_object_msgs__srv__GetShapeArray_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__srv__GetShapeArray_Request * data = NULL;

  if (size) {
    data = (tuw_object_msgs__srv__GetShapeArray_Request *)allocator.zero_allocate(size, sizeof(tuw_object_msgs__srv__GetShapeArray_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_object_msgs__srv__GetShapeArray_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_object_msgs__srv__GetShapeArray_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_object_msgs__srv__GetShapeArray_Request__Sequence__fini(tuw_object_msgs__srv__GetShapeArray_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_object_msgs__srv__GetShapeArray_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_object_msgs__srv__GetShapeArray_Request__Sequence *
tuw_object_msgs__srv__GetShapeArray_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__srv__GetShapeArray_Request__Sequence * array = (tuw_object_msgs__srv__GetShapeArray_Request__Sequence *)allocator.allocate(sizeof(tuw_object_msgs__srv__GetShapeArray_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_object_msgs__srv__GetShapeArray_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_object_msgs__srv__GetShapeArray_Request__Sequence__destroy(tuw_object_msgs__srv__GetShapeArray_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_object_msgs__srv__GetShapeArray_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_object_msgs__srv__GetShapeArray_Request__Sequence__are_equal(const tuw_object_msgs__srv__GetShapeArray_Request__Sequence * lhs, const tuw_object_msgs__srv__GetShapeArray_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_object_msgs__srv__GetShapeArray_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_object_msgs__srv__GetShapeArray_Request__Sequence__copy(
  const tuw_object_msgs__srv__GetShapeArray_Request__Sequence * input,
  tuw_object_msgs__srv__GetShapeArray_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_object_msgs__srv__GetShapeArray_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_object_msgs__srv__GetShapeArray_Request * data =
      (tuw_object_msgs__srv__GetShapeArray_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_object_msgs__srv__GetShapeArray_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_object_msgs__srv__GetShapeArray_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_object_msgs__srv__GetShapeArray_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `shapes`
#include "tuw_object_msgs/msg/detail/shape_array__functions.h"

bool
tuw_object_msgs__srv__GetShapeArray_Response__init(tuw_object_msgs__srv__GetShapeArray_Response * msg)
{
  if (!msg) {
    return false;
  }
  // shapes
  if (!tuw_object_msgs__msg__ShapeArray__init(&msg->shapes)) {
    tuw_object_msgs__srv__GetShapeArray_Response__fini(msg);
    return false;
  }
  return true;
}

void
tuw_object_msgs__srv__GetShapeArray_Response__fini(tuw_object_msgs__srv__GetShapeArray_Response * msg)
{
  if (!msg) {
    return;
  }
  // shapes
  tuw_object_msgs__msg__ShapeArray__fini(&msg->shapes);
}

bool
tuw_object_msgs__srv__GetShapeArray_Response__are_equal(const tuw_object_msgs__srv__GetShapeArray_Response * lhs, const tuw_object_msgs__srv__GetShapeArray_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // shapes
  if (!tuw_object_msgs__msg__ShapeArray__are_equal(
      &(lhs->shapes), &(rhs->shapes)))
  {
    return false;
  }
  return true;
}

bool
tuw_object_msgs__srv__GetShapeArray_Response__copy(
  const tuw_object_msgs__srv__GetShapeArray_Response * input,
  tuw_object_msgs__srv__GetShapeArray_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // shapes
  if (!tuw_object_msgs__msg__ShapeArray__copy(
      &(input->shapes), &(output->shapes)))
  {
    return false;
  }
  return true;
}

tuw_object_msgs__srv__GetShapeArray_Response *
tuw_object_msgs__srv__GetShapeArray_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__srv__GetShapeArray_Response * msg = (tuw_object_msgs__srv__GetShapeArray_Response *)allocator.allocate(sizeof(tuw_object_msgs__srv__GetShapeArray_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_object_msgs__srv__GetShapeArray_Response));
  bool success = tuw_object_msgs__srv__GetShapeArray_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_object_msgs__srv__GetShapeArray_Response__destroy(tuw_object_msgs__srv__GetShapeArray_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_object_msgs__srv__GetShapeArray_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_object_msgs__srv__GetShapeArray_Response__Sequence__init(tuw_object_msgs__srv__GetShapeArray_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__srv__GetShapeArray_Response * data = NULL;

  if (size) {
    data = (tuw_object_msgs__srv__GetShapeArray_Response *)allocator.zero_allocate(size, sizeof(tuw_object_msgs__srv__GetShapeArray_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_object_msgs__srv__GetShapeArray_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_object_msgs__srv__GetShapeArray_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_object_msgs__srv__GetShapeArray_Response__Sequence__fini(tuw_object_msgs__srv__GetShapeArray_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_object_msgs__srv__GetShapeArray_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_object_msgs__srv__GetShapeArray_Response__Sequence *
tuw_object_msgs__srv__GetShapeArray_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__srv__GetShapeArray_Response__Sequence * array = (tuw_object_msgs__srv__GetShapeArray_Response__Sequence *)allocator.allocate(sizeof(tuw_object_msgs__srv__GetShapeArray_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_object_msgs__srv__GetShapeArray_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_object_msgs__srv__GetShapeArray_Response__Sequence__destroy(tuw_object_msgs__srv__GetShapeArray_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_object_msgs__srv__GetShapeArray_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_object_msgs__srv__GetShapeArray_Response__Sequence__are_equal(const tuw_object_msgs__srv__GetShapeArray_Response__Sequence * lhs, const tuw_object_msgs__srv__GetShapeArray_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_object_msgs__srv__GetShapeArray_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_object_msgs__srv__GetShapeArray_Response__Sequence__copy(
  const tuw_object_msgs__srv__GetShapeArray_Response__Sequence * input,
  tuw_object_msgs__srv__GetShapeArray_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_object_msgs__srv__GetShapeArray_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_object_msgs__srv__GetShapeArray_Response * data =
      (tuw_object_msgs__srv__GetShapeArray_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_object_msgs__srv__GetShapeArray_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_object_msgs__srv__GetShapeArray_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_object_msgs__srv__GetShapeArray_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
