// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_object_msgs:srv/GetShapeArray.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__SRV__DETAIL__GET_SHAPE_ARRAY__STRUCT_HPP_
#define TUW_OBJECT_MSGS__SRV__DETAIL__GET_SHAPE_ARRAY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__tuw_object_msgs__srv__GetShapeArray_Request __attribute__((deprecated))
#else
# define DEPRECATED__tuw_object_msgs__srv__GetShapeArray_Request __declspec(deprecated)
#endif

namespace tuw_object_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetShapeArray_Request_
{
  using Type = GetShapeArray_Request_<ContainerAllocator>;

  explicit GetShapeArray_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit GetShapeArray_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_object_msgs__srv__GetShapeArray_Request
    std::shared_ptr<tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_object_msgs__srv__GetShapeArray_Request
    std::shared_ptr<tuw_object_msgs::srv::GetShapeArray_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetShapeArray_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetShapeArray_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetShapeArray_Request_

// alias to use template instance with default allocator
using GetShapeArray_Request =
  tuw_object_msgs::srv::GetShapeArray_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace tuw_object_msgs


// Include directives for member types
// Member 'shapes'
#include "tuw_object_msgs/msg/detail/shape_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_object_msgs__srv__GetShapeArray_Response __attribute__((deprecated))
#else
# define DEPRECATED__tuw_object_msgs__srv__GetShapeArray_Response __declspec(deprecated)
#endif

namespace tuw_object_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetShapeArray_Response_
{
  using Type = GetShapeArray_Response_<ContainerAllocator>;

  explicit GetShapeArray_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : shapes(_init)
  {
    (void)_init;
  }

  explicit GetShapeArray_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : shapes(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _shapes_type =
    tuw_object_msgs::msg::ShapeArray_<ContainerAllocator>;
  _shapes_type shapes;

  // setters for named parameter idiom
  Type & set__shapes(
    const tuw_object_msgs::msg::ShapeArray_<ContainerAllocator> & _arg)
  {
    this->shapes = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_object_msgs__srv__GetShapeArray_Response
    std::shared_ptr<tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_object_msgs__srv__GetShapeArray_Response
    std::shared_ptr<tuw_object_msgs::srv::GetShapeArray_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetShapeArray_Response_ & other) const
  {
    if (this->shapes != other.shapes) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetShapeArray_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetShapeArray_Response_

// alias to use template instance with default allocator
using GetShapeArray_Response =
  tuw_object_msgs::srv::GetShapeArray_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace tuw_object_msgs

namespace tuw_object_msgs
{

namespace srv
{

struct GetShapeArray
{
  using Request = tuw_object_msgs::srv::GetShapeArray_Request;
  using Response = tuw_object_msgs::srv::GetShapeArray_Response;
};

}  // namespace srv

}  // namespace tuw_object_msgs

#endif  // TUW_OBJECT_MSGS__SRV__DETAIL__GET_SHAPE_ARRAY__STRUCT_HPP_
