// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_object_msgs:msg/Object.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT__STRUCT_HPP_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"
// Member 'twist'
#include "geometry_msgs/msg/detail/twist__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_object_msgs__msg__Object __attribute__((deprecated))
#else
# define DEPRECATED__tuw_object_msgs__msg__Object __declspec(deprecated)
#endif

namespace tuw_object_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Object_
{
  using Type = Object_<ContainerAllocator>;

  explicit Object_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_init),
    twist(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->shape = 0l;
    }
  }

  explicit Object_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_alloc, _init),
    twist(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->shape = 0l;
    }
  }

  // field types and members
  using _ids_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _ids_type ids;
  using _shape_type =
    int32_t;
  _shape_type shape;
  using _shape_variables_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _shape_variables_type shape_variables;
  using _ids_confidence_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _ids_confidence_type ids_confidence;
  using _pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _pose_type pose;
  using _twist_type =
    geometry_msgs::msg::Twist_<ContainerAllocator>;
  _twist_type twist;

  // setters for named parameter idiom
  Type & set__ids(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->ids = _arg;
    return *this;
  }
  Type & set__shape(
    const int32_t & _arg)
  {
    this->shape = _arg;
    return *this;
  }
  Type & set__shape_variables(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->shape_variables = _arg;
    return *this;
  }
  Type & set__ids_confidence(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->ids_confidence = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__twist(
    const geometry_msgs::msg::Twist_<ContainerAllocator> & _arg)
  {
    this->twist = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t SHAPE_UNKOWN =
    0;
  static constexpr int32_t SHAPE_POINT =
    1;
  static constexpr int32_t SHAPE_CIRCLE =
    2;
  static constexpr int32_t SHAPE_ELLIPSE =
    3;
  static constexpr int32_t SHAPE_SQUARE =
    4;
  static constexpr int32_t SHAPE_RECTANGLE =
    5;
  static constexpr int32_t SHAPE_HULL =
    6;
  static constexpr int32_t SHAPE_LINE =
    7;
  static constexpr int32_t SHAPE_SPHERE =
    102;
  static constexpr int32_t SHAPE_ELLIPSOID =
    103;
  static constexpr int32_t SHAPE_CUBE =
    104;
  static constexpr int32_t SHAPE_BOX =
    105;
  static constexpr int32_t SHAPE_MESH =
    106;
  static constexpr int32_t SHAPE_TRAFFIC_CONE =
    201;
  static constexpr int32_t SHAPE_DOOR =
    202;
  static constexpr int32_t SHAPE_MAP_DOOR =
    212;
  static constexpr int32_t SHAPE_PERSON =
    203;
  static constexpr int32_t SHAPE_VEHICLE =
    204;
  static constexpr int32_t SHAPE_FIDUCIAL =
    205;
  static constexpr int32_t SHAPE_CONE =
    206;

  // pointer types
  using RawPtr =
    tuw_object_msgs::msg::Object_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_object_msgs::msg::Object_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_object_msgs::msg::Object_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_object_msgs::msg::Object_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::msg::Object_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::msg::Object_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::msg::Object_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::msg::Object_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_object_msgs::msg::Object_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_object_msgs::msg::Object_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_object_msgs__msg__Object
    std::shared_ptr<tuw_object_msgs::msg::Object_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_object_msgs__msg__Object
    std::shared_ptr<tuw_object_msgs::msg::Object_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Object_ & other) const
  {
    if (this->ids != other.ids) {
      return false;
    }
    if (this->shape != other.shape) {
      return false;
    }
    if (this->shape_variables != other.shape_variables) {
      return false;
    }
    if (this->ids_confidence != other.ids_confidence) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->twist != other.twist) {
      return false;
    }
    return true;
  }
  bool operator!=(const Object_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Object_

// alias to use template instance with default allocator
using Object =
  tuw_object_msgs::msg::Object_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_UNKOWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_POINT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_CIRCLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_ELLIPSE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_SQUARE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_RECTANGLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_HULL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_LINE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_SPHERE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_ELLIPSOID;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_CUBE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_BOX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_MESH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_TRAFFIC_CONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_DOOR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_MAP_DOOR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_PERSON;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_VEHICLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_FIDUCIAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t Object_<ContainerAllocator>::SHAPE_CONE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace tuw_object_msgs

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT__STRUCT_HPP_
