// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_object_msgs:msg/ObjectDetection.idl
// generated code does not contain a copyright notice
#include "tuw_object_msgs/msg/detail/object_detection__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `view_direction`
#include "geometry_msgs/msg/detail/quaternion__functions.h"
// Member `type`
// Member `sensor_type`
#include "rosidl_runtime_c/string_functions.h"
// Member `objects`
#include "tuw_object_msgs/msg/detail/object_with_covariance__functions.h"

bool
tuw_object_msgs__msg__ObjectDetection__init(tuw_object_msgs__msg__ObjectDetection * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    tuw_object_msgs__msg__ObjectDetection__fini(msg);
    return false;
  }
  // distance_min
  // distance_max
  // distance_max_id
  // view_direction
  if (!geometry_msgs__msg__Quaternion__init(&msg->view_direction)) {
    tuw_object_msgs__msg__ObjectDetection__fini(msg);
    return false;
  }
  // fov_horizontal
  // fov_vertical
  // type
  if (!rosidl_runtime_c__String__init(&msg->type)) {
    tuw_object_msgs__msg__ObjectDetection__fini(msg);
    return false;
  }
  // objects
  if (!tuw_object_msgs__msg__ObjectWithCovariance__Sequence__init(&msg->objects, 0)) {
    tuw_object_msgs__msg__ObjectDetection__fini(msg);
    return false;
  }
  // sensor_type
  if (!rosidl_runtime_c__String__init(&msg->sensor_type)) {
    tuw_object_msgs__msg__ObjectDetection__fini(msg);
    return false;
  }
  return true;
}

void
tuw_object_msgs__msg__ObjectDetection__fini(tuw_object_msgs__msg__ObjectDetection * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // distance_min
  // distance_max
  // distance_max_id
  // view_direction
  geometry_msgs__msg__Quaternion__fini(&msg->view_direction);
  // fov_horizontal
  // fov_vertical
  // type
  rosidl_runtime_c__String__fini(&msg->type);
  // objects
  tuw_object_msgs__msg__ObjectWithCovariance__Sequence__fini(&msg->objects);
  // sensor_type
  rosidl_runtime_c__String__fini(&msg->sensor_type);
}

bool
tuw_object_msgs__msg__ObjectDetection__are_equal(const tuw_object_msgs__msg__ObjectDetection * lhs, const tuw_object_msgs__msg__ObjectDetection * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // distance_min
  if (lhs->distance_min != rhs->distance_min) {
    return false;
  }
  // distance_max
  if (lhs->distance_max != rhs->distance_max) {
    return false;
  }
  // distance_max_id
  if (lhs->distance_max_id != rhs->distance_max_id) {
    return false;
  }
  // view_direction
  if (!geometry_msgs__msg__Quaternion__are_equal(
      &(lhs->view_direction), &(rhs->view_direction)))
  {
    return false;
  }
  // fov_horizontal
  if (lhs->fov_horizontal != rhs->fov_horizontal) {
    return false;
  }
  // fov_vertical
  if (lhs->fov_vertical != rhs->fov_vertical) {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  // objects
  if (!tuw_object_msgs__msg__ObjectWithCovariance__Sequence__are_equal(
      &(lhs->objects), &(rhs->objects)))
  {
    return false;
  }
  // sensor_type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->sensor_type), &(rhs->sensor_type)))
  {
    return false;
  }
  return true;
}

bool
tuw_object_msgs__msg__ObjectDetection__copy(
  const tuw_object_msgs__msg__ObjectDetection * input,
  tuw_object_msgs__msg__ObjectDetection * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // distance_min
  output->distance_min = input->distance_min;
  // distance_max
  output->distance_max = input->distance_max;
  // distance_max_id
  output->distance_max_id = input->distance_max_id;
  // view_direction
  if (!geometry_msgs__msg__Quaternion__copy(
      &(input->view_direction), &(output->view_direction)))
  {
    return false;
  }
  // fov_horizontal
  output->fov_horizontal = input->fov_horizontal;
  // fov_vertical
  output->fov_vertical = input->fov_vertical;
  // type
  if (!rosidl_runtime_c__String__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  // objects
  if (!tuw_object_msgs__msg__ObjectWithCovariance__Sequence__copy(
      &(input->objects), &(output->objects)))
  {
    return false;
  }
  // sensor_type
  if (!rosidl_runtime_c__String__copy(
      &(input->sensor_type), &(output->sensor_type)))
  {
    return false;
  }
  return true;
}

tuw_object_msgs__msg__ObjectDetection *
tuw_object_msgs__msg__ObjectDetection__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__msg__ObjectDetection * msg = (tuw_object_msgs__msg__ObjectDetection *)allocator.allocate(sizeof(tuw_object_msgs__msg__ObjectDetection), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_object_msgs__msg__ObjectDetection));
  bool success = tuw_object_msgs__msg__ObjectDetection__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_object_msgs__msg__ObjectDetection__destroy(tuw_object_msgs__msg__ObjectDetection * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_object_msgs__msg__ObjectDetection__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_object_msgs__msg__ObjectDetection__Sequence__init(tuw_object_msgs__msg__ObjectDetection__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__msg__ObjectDetection * data = NULL;

  if (size) {
    data = (tuw_object_msgs__msg__ObjectDetection *)allocator.zero_allocate(size, sizeof(tuw_object_msgs__msg__ObjectDetection), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_object_msgs__msg__ObjectDetection__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_object_msgs__msg__ObjectDetection__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_object_msgs__msg__ObjectDetection__Sequence__fini(tuw_object_msgs__msg__ObjectDetection__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_object_msgs__msg__ObjectDetection__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_object_msgs__msg__ObjectDetection__Sequence *
tuw_object_msgs__msg__ObjectDetection__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__msg__ObjectDetection__Sequence * array = (tuw_object_msgs__msg__ObjectDetection__Sequence *)allocator.allocate(sizeof(tuw_object_msgs__msg__ObjectDetection__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_object_msgs__msg__ObjectDetection__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_object_msgs__msg__ObjectDetection__Sequence__destroy(tuw_object_msgs__msg__ObjectDetection__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_object_msgs__msg__ObjectDetection__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_object_msgs__msg__ObjectDetection__Sequence__are_equal(const tuw_object_msgs__msg__ObjectDetection__Sequence * lhs, const tuw_object_msgs__msg__ObjectDetection__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_object_msgs__msg__ObjectDetection__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_object_msgs__msg__ObjectDetection__Sequence__copy(
  const tuw_object_msgs__msg__ObjectDetection__Sequence * input,
  tuw_object_msgs__msg__ObjectDetection__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_object_msgs__msg__ObjectDetection);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_object_msgs__msg__ObjectDetection * data =
      (tuw_object_msgs__msg__ObjectDetection *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_object_msgs__msg__ObjectDetection__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_object_msgs__msg__ObjectDetection__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_object_msgs__msg__ObjectDetection__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
