// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_object_msgs:msg/ObjectWithCovariance.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE__STRUCT_H_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'object'
#include "tuw_object_msgs/msg/detail/object__struct.h"
// Member 'covariance_pose'
// Member 'covariance_twist'
// Member 'correlation'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/ObjectWithCovariance in the package tuw_object_msgs.
/**
  * This expresses a object in free space with uncertainty.
 */
typedef struct tuw_object_msgs__msg__ObjectWithCovariance
{
  tuw_object_msgs__msg__Object object;
  /// Row-major representation of the 6x6 covariance matrix
  /// The orientation parameters use a fixed-axis representation.
  /// In order, the parameters are:
  /// (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
  /// pose covariance if it exists it will be 3x3 or 6x6
  rosidl_runtime_c__double__Sequence covariance_pose;
  /// twist covariance if it exists it will be 3x3 or 6x6
  rosidl_runtime_c__double__Sequence covariance_twist;
  /// correlation between pose and twist if it exists it will be 3x3 or 6x6
  rosidl_runtime_c__double__Sequence correlation;
} tuw_object_msgs__msg__ObjectWithCovariance;

// Struct for a sequence of tuw_object_msgs__msg__ObjectWithCovariance.
typedef struct tuw_object_msgs__msg__ObjectWithCovariance__Sequence
{
  tuw_object_msgs__msg__ObjectWithCovariance * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_object_msgs__msg__ObjectWithCovariance__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE__STRUCT_H_
