// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_object_msgs:msg/ObjectWithCovariance.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE__STRUCT_HPP_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'object'
#include "tuw_object_msgs/msg/detail/object__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_object_msgs__msg__ObjectWithCovariance __attribute__((deprecated))
#else
# define DEPRECATED__tuw_object_msgs__msg__ObjectWithCovariance __declspec(deprecated)
#endif

namespace tuw_object_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ObjectWithCovariance_
{
  using Type = ObjectWithCovariance_<ContainerAllocator>;

  explicit ObjectWithCovariance_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : object(_init)
  {
    (void)_init;
  }

  explicit ObjectWithCovariance_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : object(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _object_type =
    tuw_object_msgs::msg::Object_<ContainerAllocator>;
  _object_type object;
  using _covariance_pose_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _covariance_pose_type covariance_pose;
  using _covariance_twist_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _covariance_twist_type covariance_twist;
  using _correlation_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _correlation_type correlation;

  // setters for named parameter idiom
  Type & set__object(
    const tuw_object_msgs::msg::Object_<ContainerAllocator> & _arg)
  {
    this->object = _arg;
    return *this;
  }
  Type & set__covariance_pose(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->covariance_pose = _arg;
    return *this;
  }
  Type & set__covariance_twist(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->covariance_twist = _arg;
    return *this;
  }
  Type & set__correlation(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->correlation = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_object_msgs__msg__ObjectWithCovariance
    std::shared_ptr<tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_object_msgs__msg__ObjectWithCovariance
    std::shared_ptr<tuw_object_msgs::msg::ObjectWithCovariance_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ObjectWithCovariance_ & other) const
  {
    if (this->object != other.object) {
      return false;
    }
    if (this->covariance_pose != other.covariance_pose) {
      return false;
    }
    if (this->covariance_twist != other.covariance_twist) {
      return false;
    }
    if (this->correlation != other.correlation) {
      return false;
    }
    return true;
  }
  bool operator!=(const ObjectWithCovariance_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ObjectWithCovariance_

// alias to use template instance with default allocator
using ObjectWithCovariance =
  tuw_object_msgs::msg::ObjectWithCovariance_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_object_msgs

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE__STRUCT_HPP_
