// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from tuw_object_msgs:msg/ObjectWithCovarianceArrayArray.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE_ARRAY_ARRAY__FUNCTIONS_H_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE_ARRAY_ARRAY__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "tuw_object_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "tuw_object_msgs/msg/detail/object_with_covariance_array_array__struct.h"

/// Initialize msg/ObjectWithCovarianceArrayArray message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * tuw_object_msgs__msg__ObjectWithCovarianceArrayArray
 * )) before or use
 * tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
bool
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__init(tuw_object_msgs__msg__ObjectWithCovarianceArrayArray * msg);

/// Finalize msg/ObjectWithCovarianceArrayArray message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
void
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__fini(tuw_object_msgs__msg__ObjectWithCovarianceArrayArray * msg);

/// Create msg/ObjectWithCovarianceArrayArray message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray *
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__create();

/// Destroy msg/ObjectWithCovarianceArrayArray message.
/**
 * It calls
 * tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
void
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__destroy(tuw_object_msgs__msg__ObjectWithCovarianceArrayArray * msg);

/// Check for msg/ObjectWithCovarianceArrayArray message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
bool
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__are_equal(const tuw_object_msgs__msg__ObjectWithCovarianceArrayArray * lhs, const tuw_object_msgs__msg__ObjectWithCovarianceArrayArray * rhs);

/// Copy a msg/ObjectWithCovarianceArrayArray message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
bool
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__copy(
  const tuw_object_msgs__msg__ObjectWithCovarianceArrayArray * input,
  tuw_object_msgs__msg__ObjectWithCovarianceArrayArray * output);

/// Initialize array of msg/ObjectWithCovarianceArrayArray messages.
/**
 * It allocates the memory for the number of elements and calls
 * tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
bool
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence__init(tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence * array, size_t size);

/// Finalize array of msg/ObjectWithCovarianceArrayArray messages.
/**
 * It calls
 * tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
void
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence__fini(tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence * array);

/// Create array of msg/ObjectWithCovarianceArrayArray messages.
/**
 * It allocates the memory for the array and calls
 * tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence *
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence__create(size_t size);

/// Destroy array of msg/ObjectWithCovarianceArrayArray messages.
/**
 * It calls
 * tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
void
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence__destroy(tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence * array);

/// Check for msg/ObjectWithCovarianceArrayArray message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
bool
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence__are_equal(const tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence * lhs, const tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence * rhs);

/// Copy an array of msg/ObjectWithCovarianceArrayArray messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_object_msgs
bool
tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence__copy(
  const tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence * input,
  tuw_object_msgs__msg__ObjectWithCovarianceArrayArray__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE_ARRAY_ARRAY__FUNCTIONS_H_
