// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_object_msgs:msg/ObjectWithCovarianceStamped.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE_STAMPED__TRAITS_HPP_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE_STAMPED__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_object_msgs/msg/detail/object_with_covariance_stamped__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'object'
#include "tuw_object_msgs/msg/detail/object_with_covariance__traits.hpp"

namespace tuw_object_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ObjectWithCovarianceStamped & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: object
  {
    out << "object: ";
    to_flow_style_yaml(msg.object, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ObjectWithCovarianceStamped & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: object
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object:\n";
    to_block_style_yaml(msg.object, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ObjectWithCovarianceStamped & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_object_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_object_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_object_msgs::msg::ObjectWithCovarianceStamped & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_object_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_object_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_object_msgs::msg::ObjectWithCovarianceStamped & msg)
{
  return tuw_object_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_object_msgs::msg::ObjectWithCovarianceStamped>()
{
  return "tuw_object_msgs::msg::ObjectWithCovarianceStamped";
}

template<>
inline const char * name<tuw_object_msgs::msg::ObjectWithCovarianceStamped>()
{
  return "tuw_object_msgs/msg/ObjectWithCovarianceStamped";
}

template<>
struct has_fixed_size<tuw_object_msgs::msg::ObjectWithCovarianceStamped>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value && has_fixed_size<tuw_object_msgs::msg::ObjectWithCovariance>::value> {};

template<>
struct has_bounded_size<tuw_object_msgs::msg::ObjectWithCovarianceStamped>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value && has_bounded_size<tuw_object_msgs::msg::ObjectWithCovariance>::value> {};

template<>
struct is_message<tuw_object_msgs::msg::ObjectWithCovarianceStamped>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_WITH_COVARIANCE_STAMPED__TRAITS_HPP_
