// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_object_msgs:msg/Shape.idl
// generated code does not contain a copyright notice
#include "tuw_object_msgs/msg/detail/shape__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `poses`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `params_poses`
// Member `params`
#include "tuw_std_msgs/msg/detail/parameter_array__functions.h"

bool
tuw_object_msgs__msg__Shape__init(tuw_object_msgs__msg__Shape * msg)
{
  if (!msg) {
    return false;
  }
  // id
  msg->id = -1ll;
  // shape
  msg->shape = 0ul;
  // type
  msg->type = 0ul;
  // poses
  if (!geometry_msgs__msg__Pose__Sequence__init(&msg->poses, 0)) {
    tuw_object_msgs__msg__Shape__fini(msg);
    return false;
  }
  // params_poses
  if (!tuw_std_msgs__msg__ParameterArray__Sequence__init(&msg->params_poses, 0)) {
    tuw_object_msgs__msg__Shape__fini(msg);
    return false;
  }
  // params
  if (!tuw_std_msgs__msg__ParameterArray__init(&msg->params)) {
    tuw_object_msgs__msg__Shape__fini(msg);
    return false;
  }
  return true;
}

void
tuw_object_msgs__msg__Shape__fini(tuw_object_msgs__msg__Shape * msg)
{
  if (!msg) {
    return;
  }
  // id
  // shape
  // type
  // poses
  geometry_msgs__msg__Pose__Sequence__fini(&msg->poses);
  // params_poses
  tuw_std_msgs__msg__ParameterArray__Sequence__fini(&msg->params_poses);
  // params
  tuw_std_msgs__msg__ParameterArray__fini(&msg->params);
}

bool
tuw_object_msgs__msg__Shape__are_equal(const tuw_object_msgs__msg__Shape * lhs, const tuw_object_msgs__msg__Shape * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // shape
  if (lhs->shape != rhs->shape) {
    return false;
  }
  // type
  if (lhs->type != rhs->type) {
    return false;
  }
  // poses
  if (!geometry_msgs__msg__Pose__Sequence__are_equal(
      &(lhs->poses), &(rhs->poses)))
  {
    return false;
  }
  // params_poses
  if (!tuw_std_msgs__msg__ParameterArray__Sequence__are_equal(
      &(lhs->params_poses), &(rhs->params_poses)))
  {
    return false;
  }
  // params
  if (!tuw_std_msgs__msg__ParameterArray__are_equal(
      &(lhs->params), &(rhs->params)))
  {
    return false;
  }
  return true;
}

bool
tuw_object_msgs__msg__Shape__copy(
  const tuw_object_msgs__msg__Shape * input,
  tuw_object_msgs__msg__Shape * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // shape
  output->shape = input->shape;
  // type
  output->type = input->type;
  // poses
  if (!geometry_msgs__msg__Pose__Sequence__copy(
      &(input->poses), &(output->poses)))
  {
    return false;
  }
  // params_poses
  if (!tuw_std_msgs__msg__ParameterArray__Sequence__copy(
      &(input->params_poses), &(output->params_poses)))
  {
    return false;
  }
  // params
  if (!tuw_std_msgs__msg__ParameterArray__copy(
      &(input->params), &(output->params)))
  {
    return false;
  }
  return true;
}

tuw_object_msgs__msg__Shape *
tuw_object_msgs__msg__Shape__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__msg__Shape * msg = (tuw_object_msgs__msg__Shape *)allocator.allocate(sizeof(tuw_object_msgs__msg__Shape), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_object_msgs__msg__Shape));
  bool success = tuw_object_msgs__msg__Shape__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_object_msgs__msg__Shape__destroy(tuw_object_msgs__msg__Shape * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_object_msgs__msg__Shape__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_object_msgs__msg__Shape__Sequence__init(tuw_object_msgs__msg__Shape__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__msg__Shape * data = NULL;

  if (size) {
    data = (tuw_object_msgs__msg__Shape *)allocator.zero_allocate(size, sizeof(tuw_object_msgs__msg__Shape), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_object_msgs__msg__Shape__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_object_msgs__msg__Shape__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_object_msgs__msg__Shape__Sequence__fini(tuw_object_msgs__msg__Shape__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_object_msgs__msg__Shape__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_object_msgs__msg__Shape__Sequence *
tuw_object_msgs__msg__Shape__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_object_msgs__msg__Shape__Sequence * array = (tuw_object_msgs__msg__Shape__Sequence *)allocator.allocate(sizeof(tuw_object_msgs__msg__Shape__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_object_msgs__msg__Shape__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_object_msgs__msg__Shape__Sequence__destroy(tuw_object_msgs__msg__Shape__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_object_msgs__msg__Shape__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_object_msgs__msg__Shape__Sequence__are_equal(const tuw_object_msgs__msg__Shape__Sequence * lhs, const tuw_object_msgs__msg__Shape__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_object_msgs__msg__Shape__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_object_msgs__msg__Shape__Sequence__copy(
  const tuw_object_msgs__msg__Shape__Sequence * input,
  tuw_object_msgs__msg__Shape__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_object_msgs__msg__Shape);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_object_msgs__msg__Shape * data =
      (tuw_object_msgs__msg__Shape *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_object_msgs__msg__Shape__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_object_msgs__msg__Shape__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_object_msgs__msg__Shape__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
