// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_object_msgs:msg/Shape.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__SHAPE__STRUCT_H_
#define TUW_OBJECT_MSGS__MSG__DETAIL__SHAPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SHAPE_NA'.
enum
{
  tuw_object_msgs__msg__Shape__SHAPE_NA = 0ul
};

/// Constant 'SHAPE_POINT'.
enum
{
  tuw_object_msgs__msg__Shape__SHAPE_POINT = 1ul
};

/// Constant 'SHAPE_LINE'.
enum
{
  tuw_object_msgs__msg__Shape__SHAPE_LINE = 2ul
};

/// Constant 'SHAPE_LINE_STRIP'.
enum
{
  tuw_object_msgs__msg__Shape__SHAPE_LINE_STRIP = 3ul
};

/// Constant 'SHAPE_CIRCLE'.
enum
{
  tuw_object_msgs__msg__Shape__SHAPE_CIRCLE = 4ul
};

/// Constant 'SHAPE_POLYGON'.
enum
{
  tuw_object_msgs__msg__Shape__SHAPE_POLYGON = 5ul
};

/// Constant 'SHAPE_RECTANGLE'.
enum
{
  tuw_object_msgs__msg__Shape__SHAPE_RECTANGLE = 6ul
};

/// Constant 'TYPE_NA'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_NA = 0ul
};

/// Constant 'TYPE_MAP'.
/**
  * map of shape rectangle, used to define a map frame
 */
enum
{
  tuw_object_msgs__msg__Shape__TYPE_MAP = 100ul
};

/// Constant 'TYPE_PLANT'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_PLANT = 200ul
};

/// Constant 'TYPE_PLANT_WINE_ROW'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_PLANT_WINE_ROW = 201ul
};

/// Constant 'TYPE_OBSTACLE'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_OBSTACLE = 300ul
};

/// Constant 'TYPE_OBSTACLE_HOUSE'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_OBSTACLE_HOUSE = 301ul
};

/// Constant 'TYPE_OBSTACLE_TREE'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_OBSTACLE_TREE = 302ul
};

/// Constant 'TYPE_TRANSIT'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_TRANSIT = 400ul
};

/// Constant 'TYPE_TRANSIT_STREET'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_TRANSIT_STREET = 401ul
};

/// Constant 'TYPE_TRANSIT_GRAVEL'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_TRANSIT_GRAVEL = 402ul
};

/// Constant 'TYPE_WALL'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_WALL = 500ul
};

/// Constant 'TYPE_WALL_ROOM'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_WALL_ROOM = 501ul
};

/// Constant 'TYPE_WALL_HALLWAY'.
enum
{
  tuw_object_msgs__msg__Shape__TYPE_WALL_HALLWAY = 502ul
};

// Include directives for member types
// Member 'poses'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'params_poses'
// Member 'params'
#include "tuw_std_msgs/msg/detail/parameter_array__struct.h"

/// Struct defined in msg/Shape in the package tuw_object_msgs.
typedef struct tuw_object_msgs__msg__Shape
{
  /// ID, -1 default
  int64_t id;
  /// Geometric shape, 0 default
  uint32_t shape;
  /// Type, 0 default
  uint32_t type;
  /// poses describing the shape
  geometry_msgs__msg__Pose__Sequence poses;
  /// parameters for each poses
  tuw_std_msgs__msg__ParameterArray__Sequence params_poses;
  /// parameters for the shape
  tuw_std_msgs__msg__ParameterArray params;
} tuw_object_msgs__msg__Shape;

// Struct for a sequence of tuw_object_msgs__msg__Shape.
typedef struct tuw_object_msgs__msg__Shape__Sequence
{
  tuw_object_msgs__msg__Shape * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_object_msgs__msg__Shape__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__SHAPE__STRUCT_H_
