// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_object_msgs:msg/Shape.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__SHAPE__STRUCT_HPP_
#define TUW_OBJECT_MSGS__MSG__DETAIL__SHAPE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'poses'
#include "geometry_msgs/msg/detail/pose__struct.hpp"
// Member 'params_poses'
// Member 'params'
#include "tuw_std_msgs/msg/detail/parameter_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_object_msgs__msg__Shape __attribute__((deprecated))
#else
# define DEPRECATED__tuw_object_msgs__msg__Shape __declspec(deprecated)
#endif

namespace tuw_object_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Shape_
{
  using Type = Shape_<ContainerAllocator>;

  explicit Shape_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : params(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->id = -1ll;
      this->shape = 0ul;
      this->type = 0ul;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->id = 0ll;
      this->shape = 0ul;
      this->type = 0ul;
    }
  }

  explicit Shape_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : params(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->id = -1ll;
      this->shape = 0ul;
      this->type = 0ul;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->id = 0ll;
      this->shape = 0ul;
      this->type = 0ul;
    }
  }

  // field types and members
  using _id_type =
    int64_t;
  _id_type id;
  using _shape_type =
    uint32_t;
  _shape_type shape;
  using _type_type =
    uint32_t;
  _type_type type;
  using _poses_type =
    std::vector<geometry_msgs::msg::Pose_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Pose_<ContainerAllocator>>>;
  _poses_type poses;
  using _params_poses_type =
    std::vector<tuw_std_msgs::msg::ParameterArray_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_std_msgs::msg::ParameterArray_<ContainerAllocator>>>;
  _params_poses_type params_poses;
  using _params_type =
    tuw_std_msgs::msg::ParameterArray_<ContainerAllocator>;
  _params_type params;

  // setters for named parameter idiom
  Type & set__id(
    const int64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__shape(
    const uint32_t & _arg)
  {
    this->shape = _arg;
    return *this;
  }
  Type & set__type(
    const uint32_t & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__poses(
    const std::vector<geometry_msgs::msg::Pose_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Pose_<ContainerAllocator>>> & _arg)
  {
    this->poses = _arg;
    return *this;
  }
  Type & set__params_poses(
    const std::vector<tuw_std_msgs::msg::ParameterArray_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_std_msgs::msg::ParameterArray_<ContainerAllocator>>> & _arg)
  {
    this->params_poses = _arg;
    return *this;
  }
  Type & set__params(
    const tuw_std_msgs::msg::ParameterArray_<ContainerAllocator> & _arg)
  {
    this->params = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint32_t SHAPE_NA =
    0u;
  static constexpr uint32_t SHAPE_POINT =
    1u;
  static constexpr uint32_t SHAPE_LINE =
    2u;
  static constexpr uint32_t SHAPE_LINE_STRIP =
    3u;
  static constexpr uint32_t SHAPE_CIRCLE =
    4u;
  static constexpr uint32_t SHAPE_POLYGON =
    5u;
  static constexpr uint32_t SHAPE_RECTANGLE =
    6u;
  static constexpr uint32_t TYPE_NA =
    0u;
  static constexpr uint32_t TYPE_MAP =
    100u;
  static constexpr uint32_t TYPE_PLANT =
    200u;
  static constexpr uint32_t TYPE_PLANT_WINE_ROW =
    201u;
  static constexpr uint32_t TYPE_OBSTACLE =
    300u;
  static constexpr uint32_t TYPE_OBSTACLE_HOUSE =
    301u;
  static constexpr uint32_t TYPE_OBSTACLE_TREE =
    302u;
  static constexpr uint32_t TYPE_TRANSIT =
    400u;
  static constexpr uint32_t TYPE_TRANSIT_STREET =
    401u;
  static constexpr uint32_t TYPE_TRANSIT_GRAVEL =
    402u;
  static constexpr uint32_t TYPE_WALL =
    500u;
  static constexpr uint32_t TYPE_WALL_ROOM =
    501u;
  static constexpr uint32_t TYPE_WALL_HALLWAY =
    502u;

  // pointer types
  using RawPtr =
    tuw_object_msgs::msg::Shape_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_object_msgs::msg::Shape_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_object_msgs::msg::Shape_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_object_msgs::msg::Shape_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::msg::Shape_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::msg::Shape_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_object_msgs::msg::Shape_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_object_msgs::msg::Shape_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_object_msgs::msg::Shape_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_object_msgs::msg::Shape_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_object_msgs__msg__Shape
    std::shared_ptr<tuw_object_msgs::msg::Shape_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_object_msgs__msg__Shape
    std::shared_ptr<tuw_object_msgs::msg::Shape_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Shape_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->shape != other.shape) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->poses != other.poses) {
      return false;
    }
    if (this->params_poses != other.params_poses) {
      return false;
    }
    if (this->params != other.params) {
      return false;
    }
    return true;
  }
  bool operator!=(const Shape_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Shape_

// alias to use template instance with default allocator
using Shape =
  tuw_object_msgs::msg::Shape_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::SHAPE_NA;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::SHAPE_POINT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::SHAPE_LINE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::SHAPE_LINE_STRIP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::SHAPE_CIRCLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::SHAPE_POLYGON;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::SHAPE_RECTANGLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_NA;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_MAP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_PLANT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_PLANT_WINE_ROW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_OBSTACLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_OBSTACLE_HOUSE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_OBSTACLE_TREE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_TRANSIT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_TRANSIT_STREET;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_TRANSIT_GRAVEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_WALL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_WALL_ROOM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Shape_<ContainerAllocator>::TYPE_WALL_HALLWAY;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace tuw_object_msgs

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__SHAPE__STRUCT_HPP_
