// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from tuw_object_msgs:msg/Shape.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "tuw_object_msgs/msg/detail/shape__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace tuw_object_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void Shape_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) tuw_object_msgs::msg::Shape(_init);
}

void Shape_fini_function(void * message_memory)
{
  auto typed_message = static_cast<tuw_object_msgs::msg::Shape *>(message_memory);
  typed_message->~Shape();
}

size_t size_function__Shape__poses(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<geometry_msgs::msg::Pose> *>(untyped_member);
  return member->size();
}

const void * get_const_function__Shape__poses(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<geometry_msgs::msg::Pose> *>(untyped_member);
  return &member[index];
}

void * get_function__Shape__poses(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<geometry_msgs::msg::Pose> *>(untyped_member);
  return &member[index];
}

void fetch_function__Shape__poses(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const geometry_msgs::msg::Pose *>(
    get_const_function__Shape__poses(untyped_member, index));
  auto & value = *reinterpret_cast<geometry_msgs::msg::Pose *>(untyped_value);
  value = item;
}

void assign_function__Shape__poses(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<geometry_msgs::msg::Pose *>(
    get_function__Shape__poses(untyped_member, index));
  const auto & value = *reinterpret_cast<const geometry_msgs::msg::Pose *>(untyped_value);
  item = value;
}

void resize_function__Shape__poses(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<geometry_msgs::msg::Pose> *>(untyped_member);
  member->resize(size);
}

size_t size_function__Shape__params_poses(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<tuw_std_msgs::msg::ParameterArray> *>(untyped_member);
  return member->size();
}

const void * get_const_function__Shape__params_poses(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<tuw_std_msgs::msg::ParameterArray> *>(untyped_member);
  return &member[index];
}

void * get_function__Shape__params_poses(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<tuw_std_msgs::msg::ParameterArray> *>(untyped_member);
  return &member[index];
}

void fetch_function__Shape__params_poses(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const tuw_std_msgs::msg::ParameterArray *>(
    get_const_function__Shape__params_poses(untyped_member, index));
  auto & value = *reinterpret_cast<tuw_std_msgs::msg::ParameterArray *>(untyped_value);
  value = item;
}

void assign_function__Shape__params_poses(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<tuw_std_msgs::msg::ParameterArray *>(
    get_function__Shape__params_poses(untyped_member, index));
  const auto & value = *reinterpret_cast<const tuw_std_msgs::msg::ParameterArray *>(untyped_value);
  item = value;
}

void resize_function__Shape__params_poses(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<tuw_std_msgs::msg::ParameterArray> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember Shape_message_member_array[6] = {
  {
    "id",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT64,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(tuw_object_msgs::msg::Shape, id),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "shape",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT32,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(tuw_object_msgs::msg::Shape, shape),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "type",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT32,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(tuw_object_msgs::msg::Shape, type),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "poses",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<geometry_msgs::msg::Pose>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(tuw_object_msgs::msg::Shape, poses),  // bytes offset in struct
    nullptr,  // default value
    size_function__Shape__poses,  // size() function pointer
    get_const_function__Shape__poses,  // get_const(index) function pointer
    get_function__Shape__poses,  // get(index) function pointer
    fetch_function__Shape__poses,  // fetch(index, &value) function pointer
    assign_function__Shape__poses,  // assign(index, value) function pointer
    resize_function__Shape__poses  // resize(index) function pointer
  },
  {
    "params_poses",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<tuw_std_msgs::msg::ParameterArray>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(tuw_object_msgs::msg::Shape, params_poses),  // bytes offset in struct
    nullptr,  // default value
    size_function__Shape__params_poses,  // size() function pointer
    get_const_function__Shape__params_poses,  // get_const(index) function pointer
    get_function__Shape__params_poses,  // get(index) function pointer
    fetch_function__Shape__params_poses,  // fetch(index, &value) function pointer
    assign_function__Shape__params_poses,  // assign(index, value) function pointer
    resize_function__Shape__params_poses  // resize(index) function pointer
  },
  {
    "params",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<tuw_std_msgs::msg::ParameterArray>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(tuw_object_msgs::msg::Shape, params),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers Shape_message_members = {
  "tuw_object_msgs::msg",  // message namespace
  "Shape",  // message name
  6,  // number of fields
  sizeof(tuw_object_msgs::msg::Shape),
  Shape_message_member_array,  // message members
  Shape_init_function,  // function to initialize message memory (memory has to be allocated)
  Shape_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t Shape_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &Shape_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace tuw_object_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<tuw_object_msgs::msg::Shape>()
{
  return &::tuw_object_msgs::msg::rosidl_typesupport_introspection_cpp::Shape_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, tuw_object_msgs, msg, Shape)() {
  return &::tuw_object_msgs::msg::rosidl_typesupport_introspection_cpp::Shape_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
